SystemOrganization addCategory: #ProyectoFinal!

Object subclass: #Emisor
	instanceVariableNames: 'nombre apellido DNI CUIT direccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!Emisor class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 15:06'!
conNombre: aNombre conApellido: anApellido conDNI: aDNI conCUIT: aCUIT conDireccion: aDireccion 
	^ (self new) conNombre: aNombre conApellido: anApellido conDNI: aDNI conCUIT: aCUIT conDireccion: aDireccion; yourself  ! !

!Emisor methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/10/2012 18:31'!
conNombre: aNombre  conApellido:anApellido conDNI:aDNI conCUIT:aCUIT conDireccion: aDireccion 
	nombre := aNombre.
	apellido := anApellido.
	DNI := aDNI.
	CUIT := aCUIT.
	direccion := aDireccion.
! !

Object subclass: #Order
	instanceVariableNames: 'cantidad precioTotal precioUnitario fecha emisor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

Order subclass: #OrdenCompra
	instanceVariableNames: 'direccionRecepcion formaEnvio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!OrdenCompra class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:46'!
ask: quantity price: amount
	^ self shouldNotImplement! !

!OrdenCompra class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 14:31'!
bid: quantity price: amount
	^ (self new)
		quantity: quantity price: amount;
		yourself! !

Order subclass: #OrdenVenta
	instanceVariableNames: 'medioPago fechaDisponibilidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!OrdenVenta class methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 14:31'!
ask: quantity price: amount
	^ (self new)
		quantity: quantity price: amount;
		yourself! !

!OrdenVenta class methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:47'!
bid: quantity price: amount
	^ self shouldNotImplement! !

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:49'!
ask: quantity price: amount
	^ OrdenVenta ask: quantity price: amount! !

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:49'!
bid: quantity price: amount
	^ OrdenCompra bid: quantity price: amount! !

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 14:32'!
conEmisor: anEmisor conCantidad: aCantidad conPrecioTotal: aPrecioTotal conFecha: aDate
	^ (self new)
		conEmisor: anEmisor
			conCantidad: aCantidad
			conPrecioTotal: aPrecioTotal
			conFecha: aDate;
		yourself! !

!Order methodsFor: 'protected' stamp: 'DiegoValdeblanquez 7/4/2012 23:26'!
calcularPrecioUnitario
	precioUnitario := precioTotal / cantidad! !

!Order methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 14:32'!
conEmisor: anEmisor conCantidad: aCantidad conPrecioTotal: aPrecioTotal conFecha: aDate
	emisor := anEmisor.
	cantidad := aCantidad.
	precioTotal := aPrecioTotal.
	fecha := aDate.
	self calcularPrecioUnitario! !

!Order methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 14:32'!
quantity: quantity price: amount
	cantidad := quantity.
	precioTotal := amount.
	self calcularPrecioUnitario! !

Object subclass: #OrderBook
	instanceVariableNames: 'ordenesCompra ordenesVenta precioMercado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 14:37'!
addOrder: anOrder
	"Agrega una orden al arreglo de ordenes dependiendo de su tipo"

	(anOrder isMemberOf: OrdenCompra)
		ifTrue: [ ordenesCompra add: anOrder ].
	(anOrder isMemberOf: OrdenVenta)
		ifTrue: [ ordenesVenta add: anOrder ]! !

!OrderBook methodsFor: 'initialize-release' stamp: 'PauloPerez 7/9/2012 22:00'!
initialize
	ordenesCompra := OrderedCollection new.
	ordenesVenta := OrderedCollection new! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:13'!
marketPrice
	"El Precio de Mercado es el precio nico por unidad al cual se comercializarn el producto en la etapa de Trading"

	| temporary variable names |
	^ precioMercado! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 15:02'!
tradingTickets
	"Durante esta etapa se realizan las transacciones de compra-venta del producto correspondiente al OrderBook, siempre al precio fijo establecido por el Precio de Mercado en la etapa anterior"

	| tradingTickets ordenVenta ordenCompra |
	tradingTickets := OrderedCollection new.
	tradingTickets
		add:
			(TradingTicket
				conOrdenCompra: ordenCompra
				conOrdenVenta: ordenVenta
				conPrecioMercado: precioMercado
				conFechaTransaccion: Date today).
	^ tradingTickets! !

Object subclass: #PEM
	instanceVariableNames: 'tradingTickets emisores orderBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!PEM methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/5/2012 00:08'!
addEmisor: anEmisor
	"Agrega un empleado al arreglo de empleados"

	anEmisor isNil
		ifFalse: [ emisores add: anEmisor ]! !

!PEM methodsFor: 'initialize-release' stamp: 'PauloPerez 7/9/2012 21:20'!
initialize
	tradingTickets := OrderedCollection new.
	emisores := OrderedCollection new.
	orderBook := OrderBook new! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:13'!
marketPrice
"El Precio de Mercado es el precio nico por unidad al cual se comercializarn los productos en la etapa de trading"
	^ orderBook marketPrice! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 14:37'!
recibirOrden: anOrder
	"Agrega una orden al orderBook"

	anOrder isNil
		ifFalse: [ orderBook addOrder: anOrder ]! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:11'!
tradingTickets
	"Durante esta etapa se realizan las transacciones de compra-venta de productos, siempre al precio fijo establecido por el Precio de Mercado en la etapa anterior"

	^ orderBook tradingTickets! !

Object subclass: #TradingTicket
	instanceVariableNames: 'precioMercado fechaTransaccion ordenCompra ordenVenta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!TradingTicket class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 15:33'!
conOrdenCompra: anOrdenCompra conOrdenVenta: anOrdenVenta conPrecioMercado: aPrecioMercado conFechaTransaccion: aDate
	^ (self new)
		conOrdenCompra: anOrdenCompra
			conOrdenVenta: anOrdenVenta
			conPrecioMercado: aPrecioMercado
			conFechaTransaccion: aDate;
		yourself! !

!TradingTicket methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 7/10/2012 11:56'!
conOrdenCompra: anOrdenCompra conOrdenVenta: anOrdenVenta conPrecioMercado: aPrecioMercado conFechaTransaccion: aFechaTransaccion
	"Mensaje que escribe en cada TradingTicket los datos de las ordenes de compra y venta que se puedieron efectivizar a un cierto precio de mercado calculado y definido en una fecha determinada."

	ordenCompra := anOrdenCompra.
	ordenVenta := anOrdenVenta.
	precioMercado := aPrecioMercado.
	fechaTransaccion := aFechaTransaccion! !

!TradingTicket methodsFor: 'printing' stamp: 'DiegoValdeblanquez 7/10/2012 17:04'!
printOn: aStream
	aStream
		nextPutAll: 'Orden de compra ';
		print: ordenCompra;
		space;
		space;
		nextPutAll: 'Orden de venta ';
		print: ordenVenta;
		space;
		space;
		nextPutAll: 'Precio mercado ';
		print: precioMercado;
		cr;
		nextPutAll: 'Fecha transaccin ';
		print: fechaTransaccion;
		cr.
	aStream cr! !
